/*---------------------------------------------------------------------------

	CMCoLocal.h  Header for local coordinate computig object

   Author : Luca Strabla (Bassano Bresciano Observatory)

  	Date : September 2009

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

---------------------------------------------------------------------------*/



// include antirepeat
#ifndef CMCoLocalH
#define CMCoLocalH



// project include
#include "CMHours.h"
#include "CMDegree.h"



class CMCoLocal
{
   public:
      // object constructor
                                       CMCoLocal();
      // copy object constructor
                                       CMCoLocal( const CMCoLocal *Copy );
      // destroyer
                                       ~CMCoLocal();
      // get longitude
      CMHours* const                   GetLongitude( void ) const;
      // get latitude
      CMDegree* const                  GetLatitude( void ) const;
      // get elevation
      double                           GetElevation( void ) const;
      // set elevation
      void                             SetElevation( double ParElevation ) ;
   private:
      // Longitude
      CMHours                          *Longitude;
      // Latitude
      CMDegree                         *Latitude;
      // elevation
      double                           Elevation;
};
#endif
