/*---------------------------------------------------------------------------

	CMCoRectangolar.h  Header for rectangolar coordinate computig object

   Author : Luca Strabla (Bassano Bresciano Observatory)

  	Date : September 2009

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

---------------------------------------------------------------------------*/



// include antirepeat
#ifndef CMCoRectangolarH
#define CMCoRectangolarH

class CMCoEcliptic;

class CMCoRectangolar
{
   public:
      // rectangolar position
      typedef struct
      {
         double            X;
         double            Y;
         double            Z;
      }RET_COO;

      // object constructor
                                       CMCoRectangolar();
      // copy object constructor
                                       CMCoRectangolar( CMCoRectangolar *Copy );
      // set coordinate
      int                              Set( RET_COO* Pos );
      // get coordinate
      const RET_COO*                   Get( void );
      // subtract rectangolar coordinate
      void                             Sub( CMCoRectangolar *SubEle );
      // add rectangolar coordinate
      void                             Add( CMCoRectangolar *AddEle );
      // get ecliptic coordinate
      CMCoEcliptic*                    GetCoEcl( void );
      // get distance
      double                           GetDist( void );

   private:
      RET_COO                          Coo;
};

#endif
