/*---------------------------------------------------------------------------

	MCMoon.h  Header for moon object

   Author : Luca Strabla (Bassano Bresciano Observatory)

  	Date : November 2009

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

---------------------------------------------------------------------------*/



// include antirepeat
#ifndef CMMoonH
#define CMMoonH



// project include
#include "CMObject.h"
#include "CMCoEquatorial.h"
#include "CMFunctions.h"
#include "CMVSOP.h"

class CMMoon : public CMObject
{
   public:
      // Object constructor
                                       CMMoon( void);
      // Object copy constructor
                                       CMMoon( CMMoon *Planet );
      // destroyer
      virtual                          ~CMMoon();
      // computing setting
      void                             SetOpt( bool ParNutation );
      
   protected:
      // moon position computing
      virtual void                     ComputePosition( void );

      bool                             Nutation;            // enable nutation computing
};

#endif
