/*---------------------------------------------------------------------------

	CMStarEB.h  Header for Eclipse Binary start objects

   Author : Luca Strabla (Bassano Bresciano Observatory)

  	Date : March 2012

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

---------------------------------------------------------------------------*/



// include antirepeat
#ifndef CMStarEBH
#define CMStarEBH



// system include
#include <math.h>



// project include
#include "CMStar.h"
#include "CMObject.h"
#include "CMCoEquatorial.h"



class CMStarEB : public CMStar
{
   public:
      // constructor
                                       CMStarEB( );
      // copy constructor
                                       CMStarEB( CMStarEB *Star );
      // destroyer
      virtual                          ~CMStarEB();
      // set EB parameters
      void                             SetEBParameters( double PBaseJD, double PPeriod, double PMinimumPhase, bool PNeedPrimary, bool PNeedSecondary);
      // compute next minimum
      double                           GetNextMinimum( double From, bool *Primary );
      
   protected:
      double                           BaseJD;              // base julian day for a maximum
      double                           Period;              // lightcurve period
      double                           MinimumPhase;        // Phase when minimum happen
      bool                             NeedPrimary;         // Primary minimum observaton are required
      bool                             NeedSecondary;       // Secondary minimum observaton are required
};
#endif
