/*---------------------------------------------------------------------------

	CMVSOP.h  Header for VSOP elemement compunting

   Author : Luca Strabla (Bassano Bresciano Observatory)

  	Date : September 2009

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

---------------------------------------------------------------------------*/



// include antirepeat
#ifndef CMVSOPH
#define CMVSOPH



// definitions
#define ARRAY_SIZE(a) (sizeof(a) / sizeof(a[0]))



// tern definizion
struct VSOP_Tern
{
   double                              A;
   double                              B;
   double                              C;
};

// tern serie definition
struct VSOP_Series
{
    VSOP_Tern                          *Terns;
    int                                TernNum;
};

// terns for ecliptic elements
struct VSOP_Object
{
    VSOP_Series                        *SerieL;
    VSOP_Series                        *SerieB;
    VSOP_Series                        *SerieR;
};



// compute rectangolar VSOP coordinate
CMCoRectangolar*                       CM_VSOP_ComputePosition(double jd, VSOP_Object *Object );
// sum a VSOP serie
double                                 CM_VSOP_AddSeries(const VSOP_Series *Series, double t );


// planet VSOP parametes
extern VSOP_Object                     VSOP_Mercury;
extern VSOP_Object                     VSOP_Venus;
extern VSOP_Object                     VSOP_Earth;
extern VSOP_Object                     VSOP_Mars;
extern VSOP_Object                     VSOP_Jupiter;
extern VSOP_Object                     VSOP_Saturn;
extern VSOP_Object                     VSOP_Uran;
extern VSOP_Object                     VSOP_Neptun;








#endif
