/******************************************************************************

	Config.h | Polypus configuration form header

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : March 2010

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

******************************************************************************/



// antirepeat
#ifndef ConfigH
#define ConfigH



// System include
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>



// project include
class TForm1 : public TForm
{
   __published:	// IDE-managed Components
      TButton                          *OkButton;
      TButton                          *CancelButton;
      TOpenDialog                      *SelectDir;
   TPageControl *ConfigPageControl;
   TTabSheet *TabSheet1;
   TLabel *Label1;
   TLabel *Label2;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label19;
   TLabel *Label20;
   TLabel *Label21;
   TLabel *Label17;
   TLabel *Label18;
   TLabel *Label22;
   TEdit *LongHoursEdit;
   TEdit *LongMinEdit;
   TEdit *LongSecEdit;
   TEdit *LatGradEdit;
   TEdit *LatMinEdit;
   TEdit *LatSecEdit;
   TEdit *TelescopeEdit;
   TMemo *ObserversMemo;
   TEdit *LatSignEdit;
   TTabSheet *TabSheet2;
   TLabel *Label6;
   TLabel *Label7;
   TLabel *Label14;
   TLabel *Label15;
   TLabel *Label23;
   TLabel *Label10;
   TLabel *Label34;
   TEdit *ShotDirEdit;
   TButton *ShotDirButton;
   TEdit *DarkDirEdit;
   TButton *DarkDirButton;
   TEdit *GSCDirEdit;
   TButton *GSCDirButton;
   TEdit *CatalogDirEdit;
   TButton *CatalogDirButton;
   TEdit *ScriptDirEdit;
   TButton *ScriptDirButton;
   TEdit *GSCResolutionDirEdit;
   TButton *GSCPinpointDirButton;
   TEdit *SNDirEdit;
   TButton *SNDirButton;
   TTabSheet *TabSheet3;
   TLabel *Label8;
   TLabel *r;
   TLabel *Righe;
   TLabel *Label9;
   TComboBox *CCDNameComboBox;
   TEdit *CCDRowsEdit;
   TEdit *CCDColumnEdit;
   TEdit *CCDScaleEdit;
   TTabSheet *TabSheet4;
   TLabel *Label16;
   TLabel *Label13;
   TLabel *Label12;
   TLabel *Label11;
   TLabel *Label32;
   TLabel *Label33;
   TCheckBox *CommTimeoutCheckBox;
   TEdit *SelectionsRadiusEdit;
   TEdit *SerialPowerEdit;
   TEdit *SerialLX200Edit;
   TEdit *BaudRateEdit;
   TCheckBox *DiaryCheckBox;
   TEdit *SafeElevationEdit;
   TEdit *MaxMagResolutionEdit;
   TCheckBox *PECCheckBox;
   TLabel *Label3;
   TEdit *PECAmplitudeEdit;
   TEdit *PECPhaseEdit;
   TLabel *Label24;
      void __fastcall                  FormShow(TObject *Sender);
      void __fastcall                  ShotDirButtonClick(TObject *Sender);
      void __fastcall                  DarkDirButtonClick(TObject *Sender);
      void __fastcall                  GSCDirButtonClick(TObject *Sender);
      void __fastcall                  CatalogDirButtonClick(TObject *Sender);
      void __fastcall                  OkButtonClick(TObject *Sender);
   void __fastcall ScriptDirButtonClick(TObject *Sender);
   void __fastcall GSCPinpointDirButtonClick(TObject *Sender);
   void __fastcall SNDirButtonClick(TObject *Sender);
   private:
   public:
      __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
