/******************************************************************************

	Keywords.h | Definition of commands and parameters for script language

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : October 2010

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

******************************************************************************/



// antirepeat
#ifndef KeyWordsH
#define KeyWordsH



/******************************************************************************

	Commands

******************************************************************************/

#define                                KEYWORD_GOTO         "punta"       //
#define                                KEYWORD_TRACKING     "motoorario"
#define                                KEYWORD_DOME         "cupola"
#define                                KEYWORD_SSHUTTER     "scorrevole"
#define                                KEYWORD_BSHUTTER     "ribaltabile"
#define                                KEYWORD_DECONDENCE   "ventola"
#define                                KWYWORD_POWER        "quadro"
#define                                KEYWORD_SHOT         "fotografia"
#define                                KEYWORD_FLAT         "flat"
#define                                KEYWORD_DARK         "dark"
#define                                KEYWORD_SKYCHECK     "controllocielo"
#define                                KEYWORD_WAIT         "attendi"     //
#define                                KEYWORD_REPEAT       "ripeti"
#define                                KEYWORD_ENDREPEAT    "fineripeti"
#define                                KEYWORD_VELOCITY     "velocita"
#define                                KEYWORD_ALLIGN       "allinea"
#define                                KEYWORD_SEARHSN      "cercasn"



/******************************************************************************

	Parameters

******************************************************************************/

#define                                PARAMETER_PLANET     "pianeta"
#define                                PARAMETER_GRB        "grb"
#define                                PARAMETER_EQUATORIAL "equ"
#define                                PARAMETER_EQU2000    "equ2000"
#define                                PARAMETER_ALTAZIMUT  "alt"
#define                                PARAMETER_MPLANET    "pianetino"
#define                                PARAMETER_NEBULA     "nebulosa"
#define                                PARAMETER_CLUSTER    "ammasso"
#define                                PARAMETER_GALAXY     "galassia"
#define                                PARAMETER_STAR       "stella"
#define                                PARAMETER_HOME       "riposo"
#define                                PARAMETER_ON         "accendi"
#define                                PARAMETER_OFF        "spegni"
#define                                PARAMETER_AUTO       "automatico"
#define                                PARAMETER_ZERO       "zero"
#define                                PARAMETER_OPEN       "apri"
#define                                PARAMETER_CLOSE      "chiudi"
#define                                PARAMETER_TIMES      "volte"
#define                                PARAMETER_UPTO       "fino"

#endif


