/******************************************************************************

	LogObserver.h Header for log  observer

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : 		July 2010

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

******************************************************************************/



// antirepeat
#ifndef LogObserverH
#define LogObserverH



// system include
#include <vcl.h>



// project include
#include "Observer.h"
#include "TentaclesMgr.h"



// definitions
#define VERSION                        "1.9"



class LogObserver : public Observer
{
	public:
      // constructor
                                       LogObserver( );
      // destroyer
      virtual                          ~LogObserver( );
      // set subject
      int                              SetSubject( TentaclesMgr *APuntSubject );
      // set file for log storing
      void                             SetFileName( char *AFileName );
      // set memo to show messages
      void                             SetMemo( TMemo *APuntMemo );

   private:
      TentaclesMgr                     *PuntSubject;        // pointer to subject
      char                             FileName[MAXPATH];   // file where store log
      TMemo                            *PuntMemo;           // pointer to memo
      const char                       *NameOnObservatory;  // observer name on observatory
      const char                       *NameOnCCD;          // observer name on CCD

      // detect all notifications
      virtual void                     Update( int ANotifyCode );
};


#endif
