/******************************************************************************

	ManualControlObserver.h Header for Main form observer

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : 		April 2010

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

******************************************************************************/



// antirepeat
#ifndef ManualControlObserverH
#define ManualControlObserverH



// project include
#include "Observer.h"
#include "TentaclesMgr.h"



class TMainForm;

class ManualControlObserver : public Observer
{
	public:
      // constructor
                                       ManualControlObserver( );
      // destroyer
      virtual                          ~ManualControlObserver( );
      // set subject
      int                              SetSubject( TentaclesMgr *APuntSubject );
      // set subject
      TentaclesMgr *                   GetSubject( void );
      // set main form object
      void                             SetMF( TMainForm *APuntMF );

   private:
      TentaclesMgr                     *PuntSubject;        // pointer to subject
      TMainForm                        *PuntMF;             // pointer to main form

      // send to main form all notifications
      virtual void                     Update( int ANotifyCode );
};


#endif
