/******************************************************************************

	SNFMF.h | Header SN finder main form

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : November 2011

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   SNF - Supernovae finder
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus and SNF
   Polypus ans SNF are free software: you can redistribute it and/or modify
   them under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus ans SNF are distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it

******************************************************************************/



// include antirepeat
#ifndef PulisceMFH
#define PulisceMFH



// system include
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <Graphics.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Classes.hpp>


// project include
#include "ImageCompare.h"
#include "Fits.h"
#include <Menus.hpp>


class TForm1 : public TForm
{
   __published:	// IDE-managed Components
      TStatusBar                       *StatusBar;
      TOpenDialog                      *DirDialog;
   TButton *Button1;
   TEdit *FolderEdit;
   TButton *FolderButton;
   TLabel *Label1;
      void __fastcall                  FormDestroy(TObject *Sender);
   void __fastcall Button1Click(TObject *Sender);
   void __fastcall FolderButtonClick(TObject *Sender);

   public:

      // contructor
      __fastcall                       TForm1(TComponent* Owner);

   private:
      AnsiString                       TestFolder;          // test folder
      Fits                             *Plate;              // fits loading object
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
