/******************************************************************************

	SNFConfig.cpp : Header SNF configuration form

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : August 2012

   SNF - SN automatic finder
   Copyright (C) 2009,2010,2012  Luca Pietro Strabla
   This file is part of SNF.
   SNF is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   SNF is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it

******************************************************************************/



// System include
#include <vcl.h>
#pragma hdrstop
#include <dir.h>



// project include
#include "SNFConfig.h"
#include "SNFMF.h"
#pragma package(smart_init)
#pragma resource "*.dfm"



// global variables
TForm2 *Form2;



/*---------------------------------------------------------------------------

   Costructor

---------------------------------------------------------------------------*/

__fastcall TForm2::TForm2(TComponent* Owner)
   : TForm(Owner)
{
}



/*---------------------------------------------------------------------------

   Show form

---------------------------------------------------------------------------*/

void __fastcall TForm2::FormShow(TObject *Sender)
{
   char                          Temp1[20];

   // put all values in form elements
   RefFolderEdit->Text = Form1->RefFolder;
   TestFolderEdit->Text = Form1->TestFolder;
   gcvt( Form1->Solving.DetectionThreshold, 2, Temp1);
   SigmaDetectionEdit->Text = Temp1;
   gcvt( Form1->Solving.SigmaFaintMag, 2, Temp1);
   SigmaFaintMagEdit->Text = Temp1;
   gcvt( Form1->Solving.SigmaMagIncrease, 2, Temp1);
   SigmaMagIncreaseEdit->Text = Temp1;
   gcvt( Form1->Solving.MinMagIncrease, 2, Temp1);
   MinMagIncreaseEdit->Text =  Temp1;
   ReferenceCheckBox->Checked = Form1->Solving.SkipReferencMatch;
   CreateMatchFileCheckBox->Checked = Form1->Solving.CreateMatchFile;
}



/*---------------------------------------------------------------------------

   Select reference folder

---------------------------------------------------------------------------*/

void __fastcall TForm2::RefFolderButtonClick(TObject *Sender)
{
   DirDialog->DefaultExt = "fit";                           // assign extension
   DirDialog->FileName = "*.fit";                           // assign filter
   DirDialog->InitialDir = RefFolderEdit->Text;             // assign initial folder
   if ( DirDialog->Execute() == true )                      // show dialog
      RefFolderEdit->Text = ExtractFilePath(DirDialog->FileName);    // get selected folder
}



/*---------------------------------------------------------------------------

   Select test folder

---------------------------------------------------------------------------*/

void __fastcall TForm2::TestFolderButtonClick(TObject *Sender)
{
   DirDialog->DefaultExt = "fit";                           // assign extension
   DirDialog->FileName = "*.fit";                           // assign filter
   DirDialog->InitialDir = TestFolderEdit->Text;            // assign initial folder
   if ( DirDialog->Execute() == true )                      // show dialog
      TestFolderEdit->Text = ExtractFilePath(DirDialog->FileName); // get selected folder
}



/*---------------------------------------------------------------------------

   conferme new parameters

---------------------------------------------------------------------------*/

void __fastcall TForm2::OkButtonClick(TObject *Sender)
{
   // get all values from form elements
   Form1->RefFolder = RefFolderEdit->Text;
   Form1->TestFolder = TestFolderEdit->Text;
   Form1->Solving.DetectionThreshold = atof ( SigmaDetectionEdit->Text.c_str());
   Form1->Solving.SigmaFaintMag = atof ( SigmaFaintMagEdit->Text.c_str());
   Form1->Solving.SigmaMagIncrease = atof( SigmaMagIncreaseEdit->Text.c_str());
   Form1->Solving.MinMagIncrease = atof( MinMagIncreaseEdit->Text.c_str());
   Form1->Solving.CreateMatchFile = CreateMatchFileCheckBox->Checked;
   Form1->Solving.SkipReferencMatch = ReferenceCheckBox->Checked;
}


