/******************************************************************************

	SNFConfig.cpp : SNF configuration form

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : August 2012

   SNF - SN automatic finder
   Copyright (C) 2009,2010,2012  Luca Pietro Strabla
   This file is part of SNF.
   SNF is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   SNF is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it

******************************************************************************/



// include antirepeat
#ifndef SNFConfigH
#define SNFConfigH



// system include
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>



class TForm2 : public TForm
{
__published:	// IDE-managed Components
   TEdit                               *RefFolderEdit;
   TButton                             *RefFolderButton;
   TEdit                               *TestFolderEdit;
   TButton                             *TestFolderButton;
   TButton                             *CancelButton;
   TButton                             *OkButton;
   TLabel                              *Label1;
   TLabel                              *Label2;
   TOpenDialog                         *DirDialog;
   TCheckBox                           *ReferenceCheckBox;
   TLabel                              *Label3;
   TEdit                               *SigmaFaintMagEdit;
   TLabel                              *Label4;
   TEdit                               *SigmaMagIncreaseEdit;
   TLabel                              *Label5;
   TEdit                               *MinMagIncreaseEdit;
   TCheckBox                           *CreateMatchFileCheckBox;
   TEdit *SigmaDetectionEdit;
   TLabel *Label6;

   void __fastcall                     FormShow(TObject *Sender);
   void __fastcall                     RefFolderButtonClick(TObject *Sender);
   void __fastcall                     TestFolderButtonClick(TObject *Sender);
   void __fastcall                     OkButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   __fastcall                          TForm2(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm2 *Form2;
//---------------------------------------------------------------------------
#endif
