/******************************************************************************

         Tokenizer.h

			Autore :		Luca
			Data :		Aprile 2002

			Header per classe di tokenizzazione da buffer

******************************************************************************/



// antiripetizione su include.

#ifndef TokenizerH
#define TokenizerH


// include di sistema
#include <windows.h>
#include <ctype.h>
#include <string.h>
#include <dir.h>




// classe
class Tokenizer
{
	public:
      // mixed definition
      typedef enum
      {
         MAXLN = 1000,  			// massima lunghezza token letto
         MAXSTR = 1001,           // massima definizione stringa
         INVALID_HANDLE = -1,					// handle invalido per token separatori
         MAX_HANDLE = 10,					// numero massimo di tabella separatori
         MAX_SEP = 10,             // lunghezza massima di un separatore
      } DEFINE;

      // errors
      typedef enum
      {
         ERR_NONE,              // nessun errore
         ERR_HANDLE,              // handle errato
         ERR_DATA,              // mancano dati
         ERR_MEM,              // errore di allocazione memoria
         ERR_END,              // fine del file
      } ERR;


   	//	Costruttore della classe
      				                     Tokenizer();
   	// Distruttore della classe
   					                     ~Tokenizer();

      // Imposta buffer di dati
      virtual void                     SetBuffer( const char *Buf, int LenBuffer );
      // Imposta la partenze del tokenizzatore
      virtual int                      Start(void);
      // Esegue la lettura di un token in formato carattere
      virtual int		                  Read( char *Token, int *Line=NULL, int *Column=NULL );

   	// Imposta serie di separatori
      int                              SetSeparators( const  char *Sep );
      // get current scan pointer
      char *                           GetScanPointer( void );

   private:
      // Tabella puntatori a tabelle separatori
      char*		                        TabSep;
   	// Puntatore di inizio buffer
      const void			               *PuntBuffer;
   	// Dimensione totale del buffer
      int			                     DimBuffer;
		// Puntatore attuale di scansione
      const void			               *PuntScan;
      // Puntatore di fine buffer
   	const void		                  *PuntEnd;
      // Riga in fase di scansione
      int			                     Riga;
      // Colonna di inizio token
      int			                     Colonna;
      // Colonna in fase di scansione
      int			                     ColonnaCorr;
};


#endif
