//---------------------------------------------------------------------------

#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <dir.h>
#include "Fits.h"



typedef void   _stdcall    (*CCD_INITIALIZE)  ( void* );
typedef int    _stdcall    (*CCD_FINALIZE)  ( void );
typedef void   _stdcall    (*CCD_SHOWDIALOG)  ( void* );
typedef int    _stdcall    (*CCD_GETOK)  ( void );
typedef int    _stdcall    (*CCD_GETHINT)  ( int );
typedef int    _stdcall    (*CCD_GETMODES)  ( char**, char**, char**, char**, char**, char**, char**, char** );
typedef char*  _stdcall    (*CCD_GETTITLE)  ( void );
typedef char*  _stdcall    (*CCD_GETSTATISTICT)  ( void );
typedef int    _stdcall    (*CCD_GETFOCUSMODES)  ( void );
typedef void   _stdcall    (*CCD_MODIFYWINDOW)  ( void );
typedef int    _stdcall    (*CCD_WINDOWMODE)  ( int, int, int, int, int );
typedef int    _stdcall    (*CCD_GUIDEWINDOWMODE)  ( int, int, int, int, int );
typedef int    _stdcall    (*CCD_GETTEMPERATURE)  ( void );
typedef int    _stdcall    (*CCD_GETWIDTH)  ( void );
typedef int    _stdcall    (*CCD_GETHIGHT)  ( void );
typedef int    _stdcall    (*CCD_GETBLOCKMODE)  ( void );
typedef int    _stdcall    (*CCD_TELESCOPE)  ( int, int );
typedef int    _stdcall    (*CCD_FILTERWHELL)  ( int, int );
typedef void   _stdcall    (*CCD_STARTDOWNLOAD)  ( void );
typedef void   _stdcall    (*CCD_READLINE)  ( unsigned short* );
typedef void   _stdcall    (*CCD_READIMAGE)  ( unsigned short* );
typedef void   _stdcall    (*CCD_ENDDOWNLOAD)  ( unsigned short*, int, int );
typedef int    _stdcall    (*CCD_STARTEXPOSURE)  ( int );
typedef void   _stdcall    (*CCD_ENDEXPOSURE)  ( void );
typedef void   _stdcall    (*CCD_STOPEXPOSURE)  ( void );
typedef void   _stdcall    (*CCD_GETSTATUS)  ( void );
typedef int    _stdcall    (*CCD_EXPOSING)  ( void );
typedef void   _stdcall    (*CCD_FASTEXPOSURE)  ( void );
typedef void   _stdcall    (*CCD_AUTOGUIDEEXPOSURE)  ( void );
typedef void   _stdcall    (*CCD_SETFOCUSIMAGING)  ( void );
typedef void   _stdcall    (*CCD_SETSELFGUIDEROWS)  ( void );
typedef int    _stdcall    (*CCD_GETFAMILY)  ( void );



   HINSTANCE               HLib;
   CCD_INITIALIZE          ccd_initialize2;
   CCD_FINALIZE            ccd_finalize2;
   CCD_SHOWDIALOG          ccd_showdialog2;
   CCD_GETOK               ccd_getok2;
   CCD_GETHINT             ccd_gethint2;
   CCD_GETMODES            ccd_getmodes2;
   CCD_GETTITLE            ccd_gettitle2;
   CCD_GETSTATISTICT       ccd_getstatistics2;
   CCD_GETFOCUSMODES       ccd_getfocusmodes2;
   CCD_MODIFYWINDOW        ccd_modifywindow2;
   CCD_WINDOWMODE          ccd_windowmode2;
   CCD_GUIDEWINDOWMODE     ccd_guidewindowmode2;
   CCD_GETTEMPERATURE      ccd_gettemperature2;
   CCD_GETWIDTH            ccd_getwidth2;
   CCD_GETHIGHT            ccd_getheight2;
   CCD_GETBLOCKMODE        ccd_getblockmode2;
   CCD_TELESCOPE           ccd_telescope2;
   CCD_FILTERWHELL         ccd_filterwheel2;
   CCD_STARTDOWNLOAD       ccd_startdownload2;
   CCD_READLINE            ccd_readline2;
   CCD_READIMAGE           ccd_readimage2;
   CCD_ENDDOWNLOAD         ccd_enddownload2;
   CCD_STARTEXPOSURE       ccd_startexposure2;
   CCD_ENDEXPOSURE         ccd_endexposure2;
   CCD_STOPEXPOSURE        ccd_stopexposure2;
   CCD_GETSTATUS           ccd_getstatus2;
   CCD_EXPOSING            ccd_exposing2;
   CCD_FASTEXPOSURE        ccd_fastexposure2;
   CCD_AUTOGUIDEEXPOSURE   ccd_autoguideexposure2;
   CCD_SETFOCUSIMAGING     ccd_setfocusimaging2;
   CCD_SETSELFGUIDEROWS    ccd_setselfguiderows2;
   CCD_GETFAMILY           ccd_getfamily2;
   char                    *Buffer;
   char                    *pw;
   int                     Len;
   int                     Tempo;

#define NUMLINEE 246
#define NUMCOL 329
#define MAXNUMFILE 20

   char                    FileList[MAXNUMFILE][MAXPATH];
   int                     NumFile;
   int                     CntFile;
   HANDLE                  hFile;
   Fits                    *Image;
   unsigned short          *Immagine=0;
   unsigned short          *ReadImm;
   int                     CCD_Width;
   int                     CCD_Height;



//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
   if ( reason == DLL_PROCESS_ATTACH )
   {
      char                          *Buffer;
      BY_HANDLE_FILE_INFORMATION    Info;
      DWORD                         ToRead;              // byte da leggere
      DWORD                         Read;                // byte letti
      char                          *p1, *p2, *p3;

      NumFile=0;
      CntFile=0;
      Image = 0;
      hFile = CreateFile( "ListaImmagini.txt", GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL );
      if ( hFile != INVALID_HANDLE_VALUE )
      {
         GetFileInformationByHandle( hFile, &Info );
         ToRead = Info.nFileSizeLow;
         Buffer = (char*)malloc ( ToRead+2 );
         ReadFile ( hFile, Buffer, ToRead, &Read, NULL);

         p1 = Buffer;
         p3 = p1 + Read;
         while ( 1 )
         {
            p2 = p1;
            while ( *p2 != '\r' && p2 <= p3 )
               *p2++;
            if ( *p2 != '\r' )
               break;
            *p2 = 0;
            strcpy( FileList[NumFile], p1 );
            p1 = p2+2;
            NumFile++;
            if ( NumFile >= MAXNUMFILE )
               break;
         }

         free ( Buffer );

         CloseHandle( hFile );
      }
   }
   if (reason == DLL_PROCESS_DETACH)
   {
   }
   return 1;
}



/***************************************************************************************************

    premendo il tasto Check sono chiamate
    ccd_initialize();      inizializza la comunicazione
    ccd_showdialog();      chiede di visualizzare una finestra di dialogo in caso di errore
    ccd_getok();           chiede se la comunicazione  ok
                           se la funzione rende 0  chimata la funzione ccd_finalize
                           se la funzione rende 1 la sequenza prosegue ed i tasti sono abilitati
   ccd_getmodes();
   ccd_getmodes();
   ccd_getfocusmodes();
   ccd_windowmode(0, 0, 100000, 100000, 0);
   ccd_getwidth();
   ccd_getheight();
   ccd_gettitle();
   ccd_getstatistics();    Chiamata periodicamente
   ccd_gethint(1);         Se impostayo binning


****************************************************************************************************/

/***************************************************************************************************

    premendo il tasto Start sono chiamate

   ccd_getfamily()                     Recupera il tipo di lettura ?
   ccd_getfamily()                     Recupera il tipo di lettura ?
   ccd_windowmode(0,0,100000,100000,1) Imposta binning
   ccd_gettemperature()                Recupera la temperatura
   ccd_startexposure(3000)             Avvia l'esposizione indicando il tempo in millesimi di secondo
   ccd_exposing                        Chiama questa funzione fino a quando restituisce 0
   ccd_endexposure                     Indica che l'esposizione  finita
   ccd_getfamily()                     Recupera il tipo di lettura ?
   ccd_startdownload()                 Comanda l'inizio del download
   ccd_getwidth();
   ccd_getheight();
   ccd_getfamily()                     Recupera il tipo di lettura ?
   ccd_getblockmode()                  chiede se si esegue il download a righe o immagine
   ccd_readline                        chiamata tante volte come definito in  ccd_getheight
   ccd_enddownload(..,0,0)             fine download con puntatore ad inzio immagine

****************************************************************************************************/


/***************************************************************************************************

    Cambiando CCD o chiudendo il programma  chiamata

      ccd_finalize            Chiude comunicazione

****************************************************************************************************/


/***************************************************************************************************

    premendo il tasto Stop durante l'esposizione

   ccd_stopexposure        Interrompe l'esposizione
   ccd_endexposure         Indica che l'esposizione  finita
   ccd_startdownload       Comanda l'inizio del download
   ccd_getblockmode        chiede se si esegue il download a righe o immagine
   ccd_readline            chiamata tante volte come definito in  ccd_getheight
   ccd_enddownload

****************************************************************************************************/




// inizializza la comunicazione
extern "C"
{


void _stdcall _export ccd_initialize( void* h)
{
   char     Messaggio[50];
}



// chiude la comunicazione
int _stdcall _export ccd_finalize(void)
{
   if ( Immagine != 0 )
      free ( Immagine );
   return 0;
}



// chiede la visualizzazione di una finestra di dialogo nel caso in cui
// la comunicazione non sia andata a buon fine
void _stdcall _export ccd_showdialog(void* h)
{
}



// definisce la finestra di ripresa
void _stdcall _export ccd_windowmode(int p1, int p2, int p3, int p4, int p5)
{
}



// quando si preme il tasto di guide
void _stdcall _export ccd_guidewindowmode(int p1, int p2, int p3, int p4, int p5 )
{
}

// ?
void _stdcall _export ccd_modifywindow(void)
{
}


// ?
int _stdcall _export ccd_getfocusmodes( void )
{
   return 0;
}

// recupera i modi di funzionamento della camera
char Modo1[] = "Modo1";
char Modo2[] = "Modo2";
char Modo3[] = "Modo3";
char Modo4[] = "Modo4";
char Modo5[] = "Modo5";
char Modo6[] = "Modo6";
char Modo7[] = "Modo7";
char Modo8[] = "Modo8";
void _stdcall _export ccd_getmodes(char **p1, char **p2, char **p3, char **p4, char **p5, char **p6, char **p7, char **p8)
{
   char     Messaggio[100];
   *p1 = Modo1;
   *p2 = Modo2;
   *p3 = Modo3;
   *p4 = Modo4;
   *p5 = Modo5;
   *p6 = Modo6;
   *p7 = Modo7;
   *p8 = Modo8;
   return;
}

// imposta il binning
//  rende qualcosa che non so FBL
void _stdcall _export ccd_gethint(int Binnig)
{
}

char titolo[] = "ABC";
// rende il titolo della finestra
char * _stdcall _export ccd_gettitle(void)
{
   return titolo;
}

// rende un testo di statistica
char statistica[] = "Statistica";
char * _stdcall _export ccd_getstatistics(void)
{
   return statistica;
}

// recupera la temperatura
// restituisce un numero intero
// resta da capire se ha i decimali
int _stdcall _export ccd_gettemperature(void)
{
   return 10;
}

// chiede numero colonne immagine
int _stdcall _export ccd_getwidth(void)
{
   int      i;
   i = NUMCOL;
   return i;
}

// chiede numero linee immagine
int _stdcall _export ccd_getheight(void)
{
   int      i;
   i = NUMLINEE;
   return i;
}

// chiede se si esegue il download a righe o immagine
// se rende 0 = righe
// se rende 1 = a immagine
int _stdcall _export ccd_getblockmode(void)
{
   int i;
   i = 0;
   return i;
}

// recupera l'informazione di comunicazione aperta
//  testato il valore di ritorno: 0 = KO, 1 OK
// nessuna pendenza
int _stdcall _export ccd_getok(void)
{
   int      i;
   i = 1;
   return i;
}

// chiamata solo se si preme il tasto telescope setting
int _stdcall _export ccd_telescope(int a, int b )
{
   char     Messaggio[50];
   int      i;
   i = 0;
   return i;
}

// chiamata solo se si preme il tasto filter well
// non dovrebbe servire
int _stdcall _export ccd_filterwheel(int a, int b)
{
   int      i;
   i = 0;
   return i;
}

int Line;
// indica inizio del download
// nessun parametro nessun ritorno
void _stdcall _export ccd_startdownload(void)
{
   Line=0;
}

// recupera una linea
void _stdcall _export ccd_readline(unsigned short *p1 )
{
   int      i,i2;
   unsigned short *p2;

   if ( Image == 0 )
   {
      for ( i=0; i<NUMCOL; i++ )
      {
         *p1 = 1000 + i + Line * 2;
         p1++;
      }
   }
   else
   {
      p2 = ReadImm + CCD_Width;
      for ( i2=0; i2<CCD_Width; i2 ++ )
      {
         p2--;
         *p1++ = *p2;
      }
      //memcpy( p1, ReadImm, CCD_Width*2 );
      ReadImm += CCD_Width;
   }
   Line++;
   return;
}

void _stdcall _export ccd_readimage(unsigned short *p1)
{
}

void _stdcall _export ccd_enddownload(unsigned short *p, int a, int b)
{
}

// avvia l'esposizione
//  passato il tempo in centesimi di secondo
// se rende 0 vuol dire che l'operazione non  riuscita
int StartExp;
int Exp;
int flg1;
int flg2;
int _stdcall _export ccd_startexposure(int p1)
{
   int      i;
   char     Messaggio[50];
   StartExp = GetTickCount();
   Exp = p1;

   if ( NumFile > 0 )
   {
      if ( Image == 0 )
         delete Image;
      Image = new Fits();
      Image->LoadFile( FileList[CntFile] );
      Image->GetImageSize( &CCD_Height, &CCD_Width );
      if ( Immagine != 0 )
         free ( Immagine );
      Immagine = (unsigned short*)malloc( CCD_Width * CCD_Height * 2);
      Image->GetImage(Immagine);
      ReadImm = Immagine;
      CntFile++;
      if ( CntFile >= NumFile )
         CntFile=0;
   }

   i = 1;
   return i;
}

// indica la fine dell'esposizione
void _stdcall _export ccd_endexposure(void)
{
   char     Messaggio[50];
   return;
}

// stoppa l'esecuzione
void _stdcall _export ccd_stopexposure(void)
{
}

// mai chiamata
void _stdcall _export ccd_getstatus(void)
{
}

// verifica che l'esposizione  finita
// se finita restituisce 0
// altrimenti restituisce un valore diverso da 0
int _stdcall _export ccd_exposing(void)
{
   char     Messaggio[50];
   int      i;
   int Now;
   i = 1;
   Now = GetTickCount();
   Now -= StartExp;
   if ( Now > Exp )
      i=0;
   return i;
}

// mai chiamata
void _stdcall _export ccd_fastexposure(void)
{
}

// mai chiamata
void _stdcall _export ccd_autoguideexposure(int i)
{
}

// mai chiamata
void _stdcall _export ccd_setfocusimaging(void)
{
}

// mai chiamata
void _stdcall _export ccd_setselfguiderows(void)
{
}

// restituisce un numero intero
// a cosa serve ?
int _stdcall _export ccd_getfamily(void)
{
   char     Messaggio[50];
   int      i;

   i = 5;
   return i;
}


}
